// (C) Copyright Andrew Bazan, 3/2000
// Feel free to make modifications or use this code in something else,
// just please give me credit where credit is due. Thanks.

#include "BeAlk3.h"

FastComplex::FastComplex()
{
	rPart = 0;
	iPart = 0;
}

FastComplex::FastComplex(const double &r, const double &i)
{
	rPart = r;
	iPart = i;
}

FastComplex FastComplex::Add(const FastComplex &rhs)
{
	double newReal = rPart + rhs.GetReal();
	double newImag = iPart + rhs.GetImag();
	
	return FastComplex(newReal, newImag);
}

FastComplex FastComplex::Square()
{
	return FastComplex((rPart * rPart) - (iPart * iPart),
		(rPart * iPart) + (iPart * rPart));
}

double FastComplex::AbsoluteValue()
{
	return sqrt((rPart * rPart) + (iPart * iPart));
}

double FastComplex::GetReal() const
{
	return rPart;
}

double FastComplex::GetImag() const
{
	return iPart;
}